'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _jsx2 = require('babel-runtime/helpers/jsx');

var _jsx3 = _interopRequireDefault(_jsx2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _connectField = require('uniforms/connectField');

var _connectField2 = _interopRequireDefault(_connectField);

var _filterDOMProps = require('uniforms/filterDOMProps');

var _filterDOMProps2 = _interopRequireDefault(_filterDOMProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Radio = function Radio(_ref) {
    var allowedValues = _ref.allowedValues,
        checkboxes = _ref.checkboxes,
        className = _ref.className,
        disabled = _ref.disabled,
        error = _ref.error,
        errorMessage = _ref.errorMessage,
        id = _ref.id,
        label = _ref.label,
        name = _ref.name,
        _onChange = _ref.onChange,
        required = _ref.required,
        showInlineError = _ref.showInlineError,
        transform = _ref.transform,
        value = _ref.value,
        props = (0, _objectWithoutProperties3.default)(_ref, ['allowedValues', 'checkboxes', 'className', 'disabled', 'error', 'errorMessage', 'id', 'label', 'name', 'onChange', 'required', 'showInlineError', 'transform', 'value']);
    return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ className: (0, _classnames2.default)(className, { disabled: disabled, error: error }, 'grouped fields') }, (0, _filterDOMProps2.default)(props)),
        label && (0, _jsx3.default)('div', {
            className: (0, _classnames2.default)({ required: required }, 'field')
        }, void 0, (0, _jsx3.default)('label', {}, void 0, label)),
        allowedValues.map(function (item) {
            return (0, _jsx3.default)('div', {
                className: 'field'
            }, item, (0, _jsx3.default)('div', {
                className: 'ui radio checkbox'
            }, void 0, (0, _jsx3.default)('input', {
                checked: item === value,
                disabled: disabled,
                id: id + '-' + item,
                name: name,
                onChange: function onChange() {
                    return _onChange(item);
                },
                type: 'radio'
            }), (0, _jsx3.default)('label', {
                htmlFor: id + '-' + item
            }, void 0, transform ? transform(item) : item)));
        }),
        !!(error && showInlineError) && (0, _jsx3.default)('div', {
            className: 'ui red basic pointing label'
        }, void 0, errorMessage)
    );
};

exports.default = (0, _connectField2.default)(Radio);